#!/usr/bin/python
import hal
h = hal.component("whee")
h.newpin("counts", hal.HAL_S32, hal.HAL_OUT)
h.ready()
import Tkinter

def count(delta):
    h.counts += delta

app = Tkinter.Tk()
app.wm_title("Whee!")
app.wm_iconname("whee")
app.bind("<Button-4>", lambda e:count(-1))
app.bind("<Button-5>", lambda e:count(1))
app.mainloop()

#    Copyright 2008 Jeff Epler <jepler@unpythonic.net>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
