#!/usr/bin/env python


from Tkinter import *
import sys

##### i hear that pygame is the best way to do very fast blitting with opengl overlay on video???
##### but have no idea how to integrate it into tkinter and the emc system??

#import pygame
#from pygame.locals import *

## the python image library is used for converting data from web cam to an image suitable for drawing on a canvas
import Image 
import ImageTk

import os, sys
import commands

use_opencv = 0

try:
	import opencv as cv
	from opencv import highgui
	use_opencv=1
except ImportError, e:
	pass # module doesn't exist, deal with it.
	use_opencv = 0
	print "No opencv module available"
	dd = commands.getstatusoutput('xterm -e ./pod.sh')

	
	
"""
if (use_opencv==1):
#opencv computer vision library is important for capturing/displaying images from webcam 
	import opencv as cv
	from opencv import highgui
"""

import EmcGuiProcs

## setup camera to capture from /dev/video0 (could change this to other cameras with different number!
camera = 0
ww = 0
sensorsffg = 0
retkpi = 0
im=0

# grab an image from the camera and return a PIL image
def get_image():
	global camera, im #ww, retkpi
	im=0
	if (use_opencv==1):
		if( camera == 0 ):
			print "loading camera /dev/video" + str(0) 
			camera = highgui.cvCreateCameraCapture(0)
		imo = im
		while ( im == imo ):
			im = highgui.cvQueryFrame(camera)
		# Add the line below if you need it (Ubuntu 8.04+)
		if(im):
			im = cv.cvGetMat(im)
		#convert Ipl image to PIL image
			return cv.adaptors.Ipl2PIL(im)
	return 0

def setcam(ddd):
	imk=0
	for ij in range(5):
		imk = get_image()
		if(imk):
			return ImageTk.PhotoImage(imk)
	if ( imk):
		print "got image"
	else:
		imk = Image.open("nocam.gif")
	if ( imk):
		print "got image load"
	else:
		print "aaarghhh"
	retkpi = ImageTk.PhotoImage(imk)
	#tkpi = PhotoImage(file = 'nocam.gif')
	return retkpi

dd=0

def getcam():
	global dd, retkpi

	dd.grid_forget()

	retkpi = setcam(dd)
	x = 160 # center of image = 120 as width = 240
	y = 120 # center of image = 85 as width = 170
	dd.create_image(x,y, image=retkpi)
	dd.grid()

ksfg=0

def encoder():
	global sensorsffg, values, button1, entry, ww, dd, ksfg
	ksfg.grid_forget()
	dd.grid_forget()
	print "encoder"


def lb_cb():
	print "encoder"

def limits():
	global sensorsffg, ksfg,dd
	dd.grid_forget()
	ffg = sensorsffg
	ksfg = Frame(ffg,height=200,width=200, bd=1)
	ksfg.grid(row=2, column=0, rowspan=2, columnspan=2, sticky=E)
	akh=Label(ksfg, text="input the limits pins max/min")
	#akh.pack(expand = 0, fill = BOTH)
	akh.grid(row=3, column=0, rowspan=2, pady=0)
	salg=Label(ksfg, text="Limit type:")
	salg.grid(row=1, column=1)
	servo_hal_paramsl = EmcGuiProcs.listbox_scroll(ksfg,salg, 0 ,["Max","Min"],range(2), lb_cb)
	print "limits"


def opts(a) :
	global sensorsffg, values, button1, entry, ww, dd, retkpi
	global alg
	global parameters
	sensorsffg = Canvas(a, height=300,width=500, relief=SUNKEN)
	ffg = sensorsffg
	#ffg.grid_propagate(0)
	akg=Label(ffg, text="Sensors configuration:")
	akg.grid(row=0, column=0, pady=0)
	button2 = Button(ffg, text="Video", command=getcam)
	button2.grid(row=0, column=2, pady=5, sticky=E)
	button3 = Button(ffg, text="Encoder", command=encoder)
	button3.grid(row=1, column=2, pady=5, sticky=E)
	button4 = Button(ffg, text="Limit switch", command=limits)
	button4.grid(row=2, column=2, pady=5, sticky=E)
	akh=Label(ffg, text="Sensors configuration on a per joint basis\n Sensors can take form of limit switches,\n or magnitude sensors, DRO scales,\n or even video cam input\nVideo configuration:\nthe frame below should show video from /dev/video0\nat some point in the future there should be\n further computer vision integration using opencv")
	#akh.pack(expand = 0, fill = BOTH)
	akh.grid(row=3, column=0, rowspan=2, pady=0)
	dd = Canvas(ffg, height=240,width=320, bd=1, relief=SUNKEN)
	dd.grid(row=2, column=0, pady=5) #, sticky=E)
	#dd.pack(expand = 1, fill = BOTH)
	#dda=Label(dd, text="Video configuration:\nthe frame below should show video from /dev/video0\nat some point in the future there should be\n further computer vision integration using opencv")
	retkpi = setcam(dd)
	#print str(retkpi.width)
	x = 160 # center of image = 120 as width = 240
	y = 120 # center of image = 85 as width = 170
	dd.create_image(x,y, image=retkpi)
	dd.create_line(0, 0, 320, 240)
	dd.create_line(0, 240, 320, 0, fill="red", dash=(4, 4))
#		ww.create_rectangle(50, 25, 150, 75, fill="blue")

def vis() :
	global sensorsffg
	sensorsffg.grid()

	

def hide() :
	global sensorsffg
	sensorsffg.grid_forget()




