#!/bin/bash



if [ source_build == 0 ]
then
sudo apt-get install g++ libtool libgtk2.0-dev libavcodec-dev libavformat-dev libjpeg62-dev libtiff4-dev python2.5-dev
sudo apt-get install libbz2-dev cmake ffmpeg
sudo apt-get install python-numpy

wget http://ovh.dl.sourceforge.net/project/opencvlibrary/opencv-unix/1.0/opencv-1.0.0.tar.gz
tar xzf opencv-1.0.0.tar.gz
cd opencv-1.0.0
./configure --prefix=/opt/opencv --enable-apps --enable-shared --with-ffmpeg --with-gnu-ld --with-x --without-quicktime CXXFLAGS=-fno-strict-aliasing
make 
sudo make install
sudo ln -sf /opt/opencv/lib/python2.5/site-packages/opencv /usr/lib/python2.5/site-packages/opencv
sudo ln -sf /opt/opencv/lib/python2.5/site-packages/opencv /usr/lib/python2.5/opencv
else
sudo apt-get install python-opencv
fi

###### the latest version of opencv dont seem to work in 8.08???
#wget http://puzzle.dl.sourceforge.net/project/opencvlibrary/opencv-unix/2.1/OpenCV-2.1.0.tar.bz2
#tar xjf OpenCV-2.1.0.tar.bz2
#cd OpenCV-2.1.0
#mkdir release
#cd release
#cmake -D CMAKE_BUILD_TYPE=RELEASE -D CMAKE_INSTALL_PREFIX=/usr/local -D BUILD_PYTHON_SUPPORT=ON .. 
#make

#sudo make install 
#sudo sudo cp -rf /opt/opencv/lib/python2.5/site-packages/opencv /usr/lib/python2.5/





###### some cad programs........


##################################################################################################
#### this installed ArtofIllusion
wget http://switch.dl.sourceforge.net/project/aoi/ArtOfIllusion/2.8.1/aoi281.zip
wget http://garr.dl.sourceforge.net/project/aoisp/Telefish%20Plugins/2.7.2/telefishAOI.jar
unzip aoi281.zip
cd ArtOfIllusion281/
sudo  apt-get install openjdk-6-jre-headless
sudo apt-get install sun-java5-jdk
sudo update-java-alternatives --set java-1.5.0-sun 
sudo update-alternatives --config java


##### this should install blender?
#sudo apt-get install blender
#

sudo apt-get install blender
# could also download and install blander from source...
# http://video.blendertestbuilds.de/download.blender.org/release/Blender2.49b/blender-2.49b-linux-glibc236-py25-i386.tar.bz2


###### instal pcb design software

wget http://heanet.dl.sourceforge.net/project/pcb/pcb/pcb-20091103/pcb-20091103.tar.gz
tar xzf pcb-20091103.tar.gz
cd pcb-20091103
sudo apt-get install libgd2-noxpm-dev
./configure
make

#####  get postscript to gcode 

wget http://www.chiark.greenend.org.uk/~alanb/ps2gc.tar.gz
tar xzf ps2gc.tar.gz
cd ps2gc
make

###### get gerber to gcode

wget http://freefr.dl.sourceforge.net/project/gerbertogcode/gerbertogcode/gerber_to_gcode0.1.7/gerber_to_gcode0_1_7.zip
unzip gerber_to_gcode0_1_7.zip
cd gerber_to_gcode0_1_7/src

####### get pcbtogcode

wget http://netcologne.dl.sourceforge.net/project/pcb2gcode/pcb2gcode/pcb2gcode-0.4.5/pcb2gcode-0.4.5.tar.bz2
tar xjf pcb2gcode-0.4.5.tar.bz2

wget http://pcbgcode.org/file.php/download/12/93/pcb-gcode-3.5.2.11.zip
unzip pcb-gcode-3.5.2.11.zip

###### get reprap repstrap programs..

wget http://fabmetheus.crsndoo.com/files/27_reprap_python_beanshell.zip
wget http://download.github.com/sam0737-hrepstrap-ee73868.tar.gz


### some idiot programs seem to need libboost which takes over 500Mb of dick space
apt-get install libboost*


