#!/usr/bin/env python
########### Author: Mungkie
########### Copyright: Mungkie 2010
########### Last update Date: July 22nd 2010
#there could be all sorts of extra functions added such as:
#	* calculating motor power required from the loads that will be lifted
#	* calculating total componded motion error
#	* calculating maximum acceleration at different joints
#	* etc.....

#we need to load the general serial kinematics, but eventually should create a more generalised dhkines


from Tkinter import *
from tkFileDialog import askopenfilename
import Image 
import ImageTk
import EmcGuiProcs
import string

import sys
import math

machine_name = "test"
pi = 3.14159265

kinematics_ini_paramnames = [  "link joint:", "ALPHA", "THETA", "A", "D", "joint type", "Joint cad definition:"]
kinematics_ini_paramvalues = [  "0", "1.570796326", "0.0", "0.0", "2.0", "revolute:prismatic", "fileopen:cylinder" ]
kinematics_ini_help = [  "this defines which joint the joint is attached to, in some cases multiple joints could be attached to the same parent joint but at present its not implemented all joints simply attach to the previously defined joint", "this is the alpha parameter", "This is the free parameter in a revolute joint", "this is the length ofset along common normal", "this is the free parameter in a prismatic joint", "this defines the type of motion the joint can make revolving about the axis or linear translation along the axis", "this defines how the joint link will look, you can load a cad .obj file (0,0,0) should be at the centre of a revolute joint. or use the standard objects (cylinder,box)" ]

kinematics_hal_paramnames = [  "link joint:", "ALPHA", "THETA", "A", "D", "joint type", "Joint cad definition:"]
kinematics_hal_params = [ "0", "1.570796326", "0.0", "0.0", "4.0", "revolute:prismatic", "fileopen:cylinder" ]

kinematics_entry = 0
kinesffg = 0

#### the following code is really really really really screwed, it is hacked from puma560gui
#### i have no idea of how puma560gui is supposed to work and how the dh parameters map to the opengl transformations????
#### would be nice if someone could offer some help
###################################################################

import paramentry

class kinematics(paramentry.paramentry):
	"this is a configuration gui for joint kinematics type config"
	ini_params = list([ list(kinematics_ini_paramnames), list(kinematics_ini_paramvalues), list(kinematics_ini_help) ])
	IOpins_out = 0	#list(servo_IOpins_out)
	IOpins_in = 0	#list(servo_IOpins_in)
	IO=0	#list(servo_IO)
	hal_params = list([0,0,0])
	ini_paramvalues = list(kinematics_ini_paramvalues)
	ini_paramvalues[6] = "cylinder"
	DRIVE_TYPES= 0

	def postinit(self) :
		######## we want to add a context sensitive help button for info about configuring DH parameters!
		button = Button(self.MainFrame, text="Help", command=self.help)
		button.grid(row=0, column=0)


	def makeGui(self,a, jnt) :
		print "#!/usr/bin/python"
		print "from vismach import *" 
		joints = list([ ])
		if ( 1 ) :
			print "import hal" 
			print "c = hal.component(\"" + machine_name + "\")" 
			for s in range(a) :
				print "c.newpin(\"joint" + str(s) + "\", hal.HAL_FLOAT, hal.HAL_IN)" 
				joints.append( "joint" + str(s) )
			#print "c.newpin(\"grip\", hal.HAL_FLOAT, hal.HAL_IN)"
			print "c.ready()"
		print "floor = Collection([Box(-50,-50,-1,50,50,0)])"
		print "floor = Color([0,1,0,0],[floor])"
		print "work = Capture()"
		print "tool = Capture()"
		print "tooltip = Capture()"
		print "tool = Collection([tooltip, tool])"
		n = 0
	############################################
	## we need to loop throught all the joint definitions and calculate the joint length
		links = list([ ]) 
		### rotation vectors for halrotate at each joint


	### damn i still dont know wtf i should be doing???
	### i think we need to take the dh params and loop through them (not in reverse order like we are here...) creating  rotation axis vectors for each joint
	### we have to define the joints in reverse as the parts must be defined as collections so they move together and you cant add a joint to a collection if its not yet defined!
	### so for each joint we then have: joint [ rotate1[x,y,z], rotate2[x,y,z], rotate3[x,y,z], ........ ] ]
	### apparently opengl scales thes to unit vectors regardless of numbers used


### then the rot_axis_vectors can be used for the halrotate commands at each joint.....

			#rot_axis_vectors = [ "1,0,0" , "1,0,0", "1,0,0", "1,0,1", "1,0,0", "0,0,1", "1,0,0" ]
		prev_joint=[0,1,0]	# we start pointing up
		rot_axis_vectors = [ ]
		num_joints=len(jnt)
	# = [ "1,0,0" , "1,0,0", "1,0,0", "1,0,1", "1,0,0", "0,0,1", "1,0,0" ]

		##### color definitions for each joint [r,g,b,a]
		colss = [ "0,0,2,1", "0,2,0,1", "2,0,0,1", "0,2,2,1", "2,0,2,1", "2,2,0,1", "0,0,2,1"]
		previous_joint_base_coords=[0,0,0]
		trrn = 0 #"0,0,0"

		prevjoint = "tool"
		deg_radians=180/pi
		"""


###########################################################################################
########### okay all the stuff below is shit but i might just be gradually inching closer to getting things working???
# i was going to sort this out but i cannot get the axis simulation  to run correctly when running g-code????



once i get axis working i will get back to this

I think the joint to link order is off by one
and the creation of links is wrong as they are extruded along z to begin with so i have to rotate them so they align correctly

		for s in range(num_joints) :
			j = current_joint_num=s
			jparams = jnt[current_joint_num][2]
			alpha=float(jparams[1])	# * deg_radians
			theta=float(jparams[2])	# * deg_radians
			A=str(jparams[3])
			D=str(jparams[4])
	#### we basically calculate the rotation axes by trig from the alpha and theta and the previous rot_axis?????
			salpha=math.sin(float(jparams[1]))
			stheta=math.sin(float(jparams[2]))
			nx =  (stheta * prev_joint[0]) 
			ny = (salpha * prev_joint[1]) * stheta
			nz = (salpha * prev_joint[2])
			#ny = sin(prev_joint[0]) * sin(prev_joint[2])
			#nz = sin(prev_joint[1]) * sin(prev_joint[0])
			#rots= tuple( nx,ny,nz )
			#sys.stdout.print "eeeeeeeee"
			vv = sys.stdout
			sys.stdout= sys.__stdout__

			p = str(nx) + "," + str(ny) + "," + str(nz)

			print "eeeeeeeee" + str(p)

			sys.stdout= vv
			rot_axis_vectors.append(p )
			prev_joint=list ( [nx,ny,nz ])
	"""
	
		rot_axis_vectors =  [ "1,0,0" , "1,0,0", "1,0,0", "1,0,1", "1,0,0", "0,0,1", "1,0,0", "0,0,1", "1,0,0" ]

		for s in range(num_joints) :
			rot_axis_vectors.append( "1,0,0" )

		######################################## we start at the furthest joint link??
		colind=0
		for s in range(num_joints) :
			j = current_joint_num=num_joints-(s+1)
			jparams = jnt[current_joint_num][2][2]
			alpha_degrees=str( round(float(jparams[1]) * deg_radians,2))
			theta_degrees=str( round(float(jparams[2]) * deg_radians,2) )
			A=str(jparams[3])
			D=str(jparams[4])
			print "\n\n# joint linkage..." + str(j)
			print "# config_params" + str(jparams)
			yradius=".5"
			cylinderlen= D	# the joint length 
			id = "link" + str(j)
			# joint linkages  represented as cylinders cylinderz creates about z axis (x1, y1radius, x2 y2radius) so could be a cone if yradius not same
			if(jparams[6]=="cylinder") :
				print id + "= CylinderY(" + str(trrn) + "," + yradius + " , " + str(float(cylinderlen) + trrn) + ", " + yradius + ")"
			### how do we create a box???
			elif (jparams[6]=="box") :
				print id + "= Box(-5.060, -5.015, 5.02, 5.060, 10.015, 1.1)"
			#### well loading a file is easy..... if its in the right format?
			else :
				##### this should load the file selected but we use a test file for now
			#	print id + "= AsciiOBJ(filename=\"" + jparams[6] + "\")"
				print id + "= AsciiOBJ(filename=\"base.obj\")"
	###### the joint 
			if(colind>5):
				colind=0
			print id + "= Color([" + colss[colind] + "], [" + id + "])"
			colind=colind+1

	################## this is all about setting the joint in the correct position to make the collection?
			# now we translate the joint to the required position
			if( float(alpha_degrees) != 0.0 ) :
				print id + " = Rotate([" + id + "]," + alpha_degrees + ",1,0,0) "
			if( float(theta_degrees) != 0 ) :
				print id + " = Rotate([" + id + "]," + theta_degrees + ",0,0,1) "
			if( float(A) != 0 ) :
				print id + "= Translate([" + id + "]," + A + ",0,0)"
			if( float(D) != 0 ) :
				print id + "= Translate([" + id + "],0,0," + D + ")"
			#if( s != 0 ) :
			print id + " = Collection([ " + id +"," + prevjoint +"])"
	######### i have no idea why the joint is moved back to its original position
	####	someone on #emc-devel suggested that all opengl operations had to be undone (i think this is wrong)
			if( float(alpha_degrees) != 0 ) :
				print id + " = Rotate([" + id + "], -" + alpha_degrees + ",1,0,0) "
			if( float(theta_degrees) != 0 ) :
				print id + " = Rotate([" + id + "], -" + theta_degrees + ",0,0,1) "
			if( float(A) != 0 ) :
				print id + "= Translate([" + id + "],-" + A + ",0,0)"
			if( float(D) != 0 ) :
				print id + "= Translate([" + id + "],0,0,-" + D + ")"

		#	print id + "= Translate([" + id + "],0,0," + str(trrn) + ")"
			prevjoint = id
			trrn = trrn + float(cylinderlen)
	########## finally we hook in the hal joint rotation point?

			"""
	some very brief notes from irc questions.........
	HalTranslate([tooltip], c, "tool_length", 0,0,-1)
	<moopy> what do the arg represent?

	<jepler> c is the hal component
	"tool_length" is the name of the pin
	0,0,-1 is the direction of the translation
	[tooltip] is the list of items to translate (a single item in this case)
	so this says: when drawing this HalTranslate object, first translate by tool_length * <0,0,-1>, then draw tooltip, then undo the translation



	<moopy> just one more question actually..... HalRotate([tool],c,"joint4",1,0,-1,0)
	<jepler> rotate around the axis <0,-1,0> (i.e., the negative Y axis) by 1*joint4 degrees
	<moopy> what are the last 4 arg in hal rotate.... a x,y,z coord + angle?
	<jepler> jkjclass HalRotate(Collection):
	<jepler>     def __init__(self, parts, comp, var, th, x, y, z):
	<jepler> I didn't remember that; I looked at the __init__ and saw that they're th (theta), x, y, and z
	<jepler>         glRotatef(th * self.comp[self.var], x, y, z)

	so last 4 are theta,x,y,z
	"""
	########################### how do we link in the motion to the hal pins????
			type=jparams[5]
			rot_= rot_axis_vectors[n]
			if( type=="prismatic"):
				print id + " = HalTranslate([" + id + "],c,\"" + joints[j ] + "\"," + rot_ + ")"
			else:
				print id + " = HalRotate([" + id + "],c,\"" + joints[j] + "\",1," + rot_ + ")"

			n = n + 1
			links.append(id)
		#dd= str(links).translate("\"", 0 )
		s = str(links) #"string. With. Punctuation? \"\"" # Sample string 
		dd = s.translate(string.maketrans("",""), "'" ) #.punctuation)
		print "\n\n\nmachine = Collection([ link1, link0])" #" + dd + ")" #[ link0])" #3, link2, link1])"
		print "model = Collection([tooltip, machine, work, floor])"
		print "main(model,tooltip, work, 150)" 
		print ""
		return


	
	message = "Denavit-Hartenberg line coordinates\n\
	\n\
	Jaques Denavit and Richard S. Hartenberg presented the first minimal representation for a line which is now widely used. The common normal between two lines was the main geometric concept that allowed Denavit and Hartenberg to find a minimal representation. Engineers use the Denavit-Hartenberg convention(D-H) to help them describe the positions of links and joints unambiguously. Every link gets its own coordinate system. There are a few rules to consider in choosing the coordinate system:\n\
	\n\
	   1. the z-axis is in the direction of the joint axis\n\
	   2. the x-axis is parallel to the common normal: x_n = z_{n - 1} \times z_n\n\
	      If there is no unique common normal (parallel z axes), then d (below) is a free\n\ parameter.\n\
	   3. the y-axis follows from the x- and z-axis by choosing it to be a right-handed coordinate system.\n\
	\n\
	Once the coordinate frames are determined, inter-link transformations are uniquely described by the following four parameters:\n\
	\n\
	    * \\theta\\,: angle about previous z, from old x to new x\n\
	    * d\\,: offset along previous z to the common normal\n\
	    * r\\,: length of the common normal (aka a, but if using this notation, do not confuse with \\alpha). Assuming a revolute joint, this is the radius about previous z.\n\
	    * \\alpha\,: angle about common normal, from old z axis to new z axis\n\
	"

	###################################################################
	def print_params(self):
		i=0
		for param in kinematics_ini_paramnames:
			print "setp " + kinstype + ".A-"  + str(i) + kinematics_ini_params[i]
			i=i+1

	###################################################################
	def print_hal(self,aa,kinstype):
		machine_name = "test"
		label = "j"
		#print "\nhhhhhhhhhhhh\n" + str(aa)
		a=aa[2]
		#kinstype ="genserkins"
		#kinstype ="dhkins"
		jointNumber = str(a[0])
		print "\n\n#" + kinstype + " hal defs for axis " + jointNumber + "\n\n"
		#### we need to set up a scale for the number of joints...
		####loadrt scale count=6
		#if(kinstype=="dhkins"):
		print "setp " + kinstype + ".ALPHA-" + jointNumber + " " + a[1]	#str( (float(a[1])/180)*pi)
		print "#setp " + kinstype + ".THETA-" + jointNumber + " " + a[2]	#str( (float(a[2])/180)*pi)
		print "setp " + kinstype + ".A-" + jointNumber + " " + str(a[3])
		print "setp " + kinstype + ".D-" + jointNumber + " " + str(a[4])
		print "addf scale." + jointNumber + " servo-thread"
		print "linksp "+ label + jointNumber + "-pos scale." + jointNumber + ".in"
		print "setp scale." + jointNumber + ".gain 1"
		print "net " + jointNumber + "scaled scale." + jointNumber + ".out "
# + machine_name + ".joint" + jointNumber
#		print "net " + jointNumber + "scaled scale." + jointNumber + ".out " + machine_name + ".joint" + jointNumber

	###################################################################
	def print_postgui_hal(self,a):
		print "net " + str(a[0]) + "scaled pyvcp.joint" + str(a[0])
		print "\n\n"

	###################################################################
	def print_ini(self,a):
		print "#genserkins ini defs for axis " + str(a[0]) + "\n"

	###################################################################
	def help(self):
		top = Toplevel()
		top.title("Help..")
		msg = Message(top, text="this is the kinematics help\n\n" + self.message)
		msg.pack()
		www = Canvas(top, width=600, height=300)
		stkpi = ImageTk.PhotoImage(file = './parameters.gif')
		www.create_image(0, 0,   image=stkpi, anchor = NW)
		www.pack()
		button = Button(top, text="Dismiss", command=top.destroy)
		button.pack()
		top.pack()

"""
###################################################################
def filerr():
	askopenfilename()

###################################################################
def setkines():
	print "set kines"

kinematics_entry = 0

###################################################################
def opts(a) :
	global kinesffg , kinematics_entry #, kinematics_ini_paramnames, kinematics_ini_params, kinematics_ini_help
	kin_para =  list([ list(kinematics_ini_paramnames), list(kinematics_ini_params), list(kinematics_ini_help)])
	kinesffg = Frame(a, height=400,width=500, bd=1, relief=SUNKEN)
	kinesffg.grid_propagate(0)
	#ffg.configure(height=400,width=500)
	akg=Label(kinesffg, text="kinematics definitions, \nplease define the parameters for joints\n please define the linkage 1)linear 2)rotary")
	akg.grid(row=0, column=0,columnspan=6)
	button4 = Button(kinesffg, text="Limit switch", command=setkines)
	button4.grid(row=1, column=0, pady=0, sticky=E)
	buh = Button(kinesffg, text="Help", command=help)
	buh.grid(row=1, column=1, pady=0, sticky=E)
	bud = Button(kinesffg, text="get cad file", command=filerr)
	bud.grid(row=1, column=2, pady=0, sticky=E)
	mffg = Frame(kinesffg, height=400,width=500, bd=1, relief=SUNKEN)
	mffg.grid(row=2, column=0, columnspan=6, pady=0, sticky=E)
	#print "new kinmatics" + str(kin_para )
	kinematics_entry = EmcGuiProcs.add_params(mffg, kin_para )

"""


