
from Tkinter import *
import sys

import EmcGuiProcs

import paramentry
servo_IOpins_in = list(paramentry.IOpins_in)

servo_IOpins_out = list(paramentry.IOpins_out)


servo_ini_paramnames = ["AXIS_","DRIVE","TYPE","HOME","MAX_VELOCITY","MAX_ACCELERATION","BACKLASH","INPUT_SCALE","OUTPUT_SCALE","MIN_LIMIT",
"MAX_LIMIT","FERROR","MIN_FERROR","HOME_OFFSET","HOME_SEARCH_VEL","HOME_LATCH_VEL","HOME_USE_INDEX",
"HOME_IGNORE_LIMITS","P","I","D","BIAS","FF0","FF1","FF2","DEADBAND"]
servo_ini_paramvalues = [ 0,1, "LINEAR:ANGULAR",0.0,3,10,0.000,60000,100.00,-10.0,16.5,0.2,2,0.0,0.0,0.0,"NO:YES","NO:YES",190,100,0.1,0.0,0,1,0.0,0.002,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

servo_ini_help = ["AXIS this defines the axis or joint number","DRIVE this defines the drive type 0=servo, 1=stepper", "TYPE defines the type of joint angular or linear","HOME defines the home position of the axis","MAX_VELOCITY","MAX_ACCELERATION","BACKLASH","INPUT_SCALE","OUTPUT_SCALE","MIN_LIMIT",
"MAX_LIMIT","FERROR","MIN_FERROR","HOME_OFFSET","HOME_SEARCH_VEL","HOME_LATCH_VEL","HOME_USE_INDEX",
"HOME_IGNORE_LIMITS","P","I","D","BIAS","FF0","FF1","FF2","DEADBAND"]

links = [ "A encoder", "B encoder", "Dir up", "Dir Down" ] 
servo_IO = [ ["A encoder", "B encoder"], ["Dir up", "Dir Down"] ] 

servo_hal_paramnames = [ "A encoder", "B encoder", "Dir up", "Dir Down"]
servo_hal_paramvalues = ["","","",""]
servo_hal_help = ["","","",""]

pwmgen_types = [ "type 0: single output","type 1: pwm/direction","type 2: up/down" ]
pwmgen_types_help = ["type 0: single output\n\
              A  single output pin, pwm, whose duty cycle is determined by the\n\
              input value for positive inputs, and which is off (or at min-dc)\n\
              for negative inputs.  Suitable for single ended circuits.",
       "type 1: pwm/direction\n\
              Two output pins, pwm and dir.  The duty cycle on pwm varies as a\n\
              function of the input value.  dir is low for positive inputs and\n\
              high for negative inputs.",
       "type 2: up/down\n\
              Two  output pins, up and down.  For positive inputs, the PWM/PDM\n\
              waveform appears on up, while down is low.  For negative inputs,\n\
\n\
              the  waveform  appears  on  down, while up is low.  Suitable for\n\
\n\
              driving two sides of an H-bridge to generate a bipolar output" ]
type0 = ["pwm"]
type1 = [ "pwm", "dir" ]
type2 = [ "up", "down" ]
pwmtypes = [ type0, type1, type2 ]



# ***********************************************************************
class servo(paramentry.paramentry):
	"this is a sevo configuration gui for an etch servo type config"
	ini_params = list([ list(servo_ini_paramnames), list(servo_ini_paramvalues), list(servo_ini_help) ])
	IOpins_out = list(servo_IOpins_out)
	IOpins_in = list(servo_IOpins_in)
	IO=list(servo_IO)
	hal_params = list([servo_hal_paramnames, servo_hal_paramvalues, servo_hal_help])
	ini_paramvalues = list(servo_ini_paramvalues)
	servoffg = 0
	DRIVE_TYPES= list(pwmgen_types)
	DRIVE_IO= list(pwmtypes)
	def get_drive(self,a):
		print "getdrive" + str(a)
		i=0
		print str(self.current_values)
		self.current_values
		for n in self.DRIVE_TYPES :
			if (a == n ) :
				print "founf"  + str(a)
				#qop['menu'].insert('end', 'command', label='foo', command=lambda : self.get_drive('foo'))
				self.IO[1]=pwmtypes[i]
				self.current_values[3][1]=["","","","","","",""]
				self.current_values[2][1]=i
				self.params_entry.set_params( [], self.current_values[2])
				self.get_optsf("out")
				#self.lb_cb(["out"])
			i=i+1

###################################################################
	def etchConfigIni(self, a):
		joint=int(a[0])
		print "\n\n#+ new axis definition\n[AXIS_"+  str(joint) + "]\n"
		i=0
		for item in servo_ini_paramnames:
			if( i > 0 ) :
				print item + " = " + str(a[2][i]) #servo_ini_params[i])
			i=i+1

###################################################################
	def etchConfigHal(self, a):
		label = "j"
		jointNumber = str(a[0])
		servoNumber = jointNumber
		inp = str(a[3][0])
		outp = str(a[3][1])
		print "\n\n# servo joint config\nnewsig " + label + jointNumber + "-pos-fb float\n\
setp encoder." + jointNumber + ".position-scale [AXIS_" + jointNumber + "]INPUT_SCALE\n\
net enc" + jointNumber + "A encoder." + jointNumber + ".phase-A <= " + str(inp[0]) + "\n\
net enc" + jointNumber + "B encoder." + jointNumber + ".phase-B <= " + str(inp[1]) + "\n\
linksp " + label + jointNumber + "-pos-fb <= encoder." + jointNumber + ".position\n\
newsig " + label + jointNumber + "-vel-cmd float\n\
linksp " + label + jointNumber + "-pos-fb => pid." + jointNumber + ".feedback\n\
linksp " + label + jointNumber + "-pos-fb => axis." + jointNumber + ".motor-pos-fb\n\
linksp " + label + jointNumber + "-vel-cmd <= pid." + jointNumber + ".output\n\
linksp " + label + jointNumber + "-vel-cmd => pwmgen." + servoNumber + ".value\n\
newsig " + label + jointNumber + "-dirup bit\n\
newsig " + label + jointNumber + "-dirdown bit\n\
linkps pwmgen." + servoNumber + ".up => " + label + jointNumber + "-dirup\n\
linkps pwmgen." + servoNumber + ".down => " + label + jointNumber + "-dirdown\n\
linksp " + label + jointNumber + "-dirup    => " + str(outp[0]) + "\n\
linksp " + label + jointNumber + "-dirdown    => " + str(outp[1]) + "\n\
setp pid." + jointNumber + ".maxoutput 1.0\n\
# the values below come from the ini\n\
setp pid." + jointNumber + ".Pgain [AXIS_" + jointNumber + "]P\n\
setp pid." + jointNumber + ".Igain [AXIS_" + jointNumber + "]I\n\
setp pid." + jointNumber + ".Dgain [AXIS_" + jointNumber + "]D\n\
setp pid." + jointNumber + ".bias [AXIS_" + jointNumber + "]BIAS\n\
setp pid." + jointNumber + ".FF0 [AXIS_" + jointNumber + "]FF0\n\
setp pid." + jointNumber + ".FF1 [AXIS_" + jointNumber + "]FF1\n\
setp pid." + jointNumber + ".FF2 [AXIS_" + jointNumber + "]FF2\n\
# deadband should be just over 1 count\n\
setp pid." + jointNumber + ".deadband [AXIS_" + jointNumber + "]DEADBAND\n\
newsig " + label + jointNumber + "-pos float\n\
linksp " + label + jointNumber + "-pos <= axis." + jointNumber + ".motor-pos-cmd\n\
linkps pid." + jointNumber + ".command <= " + label + jointNumber + "-pos\n\
newsig " + label + jointNumber + "-enable bit\n\
linkps axis." + jointNumber + ".amp-enable-out => " + label + jointNumber + "-enable\n\
linksp " + label + jointNumber + "-enable => pid." + jointNumber + ".enable \n\
linksp " + label + jointNumber + "-enable => pwmgen." + jointNumber + ".enable\n\
newsig " + label + jointNumber + "-vel float\n\
newsig " + label + jointNumber + "-acc float\n\
linksp " + label + jointNumber + "-pos => ddt." + str(int(jointNumber) * 2) + ".in\n\
linkps ddt." + str(int(jointNumber) * 2) + ".out => " + label + jointNumber + "-vel\n\
linksp " + label + jointNumber + "-vel => ddt." + str((int(jointNumber) * 2)+1) + ".in\n\
linkps ddt." + str((int(jointNumber) * 2)+1) + ".out => " + label + jointNumber + "-acc\n\
newsig " + label + jointNumber + "-flt bit\n\
linksp " + label + jointNumber + "-flt axis." + jointNumber + ".amp-fault-in"
	print ""

###################################################################
	def print_hal(self,a):
		num=int(a[0])
		if(a[1]==1):
			self.etchConfigHal( a)
###################################################################
	def print_ini(self,a):
		num=int(a[0])
		if(a[1]==1):
			self.etchConfigIni(a)




